#version 150

in vec4 osg_Vertex;
in vec3 osg_Normal;

uniform mat4 osg_ModelViewMatrix;
uniform mat4 osg_ViewMatrix;
uniform mat4 osg_ProjectionMatrix;
uniform mat3 osg_NormalMatrix;

uniform vec3 a_LightPos;

uniform vec3 a_Pose;
uniform vec3 a_PoseAnimationTarget;
uniform float a_PoseAnimationStart;
uniform float a_PoseAnimationEnd;

uniform float osg_SimulationTime;

//HOTSPOT_PRE_MAIN

void main()
{
	phong();
	
	float easeVal = easeLinear(a_PoseAnimationStart, a_PoseAnimationEnd, osg_SimulationTime);
	vec4 vertex = osg_Vertex + vec4(mix(a_Pose, a_PoseAnimationTarget, easeVal),0);
	gl_Position = osg_ProjectionMatrix * osg_ModelViewMatrix * vertex;
}