#version 150

in vec4 osg_Vertex;

uniform mat4 osg_ModelViewMatrix;
uniform mat4 osg_ProjectionMatrix;

uniform float osg_SimulationTime;

uniform vec3 a_Pose;
uniform vec3 a_PoseAnimationTarget;
uniform float a_PoseAnimationStart;
uniform float a_PoseAnimationEnd;

out vec2 v_texCoord;

//HOTSPOT_PRE_MAIN

vec4 wave(vec3 point) {
	float y = point.x*sin(point.x*8 + osg_SimulationTime)/3;
	y = y + point.x*point.z*cos(1+point.x + osg_SimulationTime)/10;
	return vec4(0, y, 0, 0);
}

void main()
{
	v_texCoord = osg_Vertex.xz;

	float easeVal = easeLinear(a_PoseAnimationStart, a_PoseAnimationEnd, osg_SimulationTime);
	vec4 vertex = osg_Vertex + vec4(mix(a_Pose, a_PoseAnimationTarget, easeVal),0);
	vertex = vertex + wave(osg_Vertex.xyz/osg_Vertex.w);
	gl_Position = osg_ProjectionMatrix * osg_ModelViewMatrix * vertex;
}