#version 150

in vec4 osg_Vertex;
in vec3 osg_Normal;

uniform mat4 osg_ModelViewMatrix;
uniform mat4 osg_ViewMatrix;
uniform mat4 osg_ProjectionMatrix;
uniform mat3 osg_NormalMatrix;
uniform vec4 a_Color;
uniform vec3 a_ItemDisplace;

uniform float osg_SimulationTime;

uniform vec3 a_LightPos;

out vec4 v_Color;

//HOTSPOT_PRE_MAIN

void main()
{
	mat4 rot = rotationMatrix(vec3(0,0,1), osg_SimulationTime);
	vec4 vert = osg_Vertex + vec4(a_ItemDisplace, 0);
	phong(rot, vert, osg_Normal);
	v_Color = a_Color;
	gl_Position = osg_ProjectionMatrix * osg_ModelViewMatrix * rot * vert;
}