#pragma once

#include "../TeetairApplication.h"
#include "../GameLoop.h"
#include "Gamehand.h"

#include "../osg/HandCamera.h"
#include "../osg/TextHUD.h"
#include "../osg/AnimatedTextHUD.h"
#include "../osg/MenuHUD.h"

#include <osg/ShapeDrawable>
#include <osgGA/TrackballManipulator>

#include <vector>

class Jenga : public TeetairApplication{

public:
	Jenga(OsgViewerWidget* osgViewerWidget);

	virtual void onFrame(const Controller& controller);
	virtual void onConnect(const Leap::Controller& controller);
	virtual void keyReleaseEvent(QKeyEvent* event);
	virtual void onSleep(PxActor**, PxU32);
	virtual void onContact(const physx::PxContactPairHeader& pairHeader, const physx::PxContactPair* pairs, physx::PxU32 nbPairs);
private:
	Gamehand* hand;
	int leapFingerResetCount = 0;
	enum objects{
		WORLD = 0,
		GROUND = 1,
		FINGER0 = 2,
		FINGER1 = 3,
		PALM = 4,
		METACARPAL = 5,
		P_PHALANGE0 = 6,
		D_PHALANGE0 = 7,
		P_PHALANGE1 = 8,
		M_PHALANGE1 = 9,
		D_PHALANGE1 = 10,
		P_PHALANGE2 = 11,
		M_PHALANGE2 = 12,
		D_PHALANGE2 = 13,
		P_PHALANGE3 = 14,
		M_PHALANGE3 = 15,
		D_PHALANGE3 = 16,
		P_PHALANGE4 = 17,
		M_PHALANGE4 = 18,
		D_PHALANGE4 = 19,
		S_PHALANGE0 = 20,
		S_PHALANGE1 = 21,
		S_PHALANGE2 = 22,
		S_PHALANGE3 = 23,
		S_PHALANGE4 = 24,
		BRICK_START = 25
	};
	enum groups{
		BRICK = 1 << 0,
		PLANE = 1 << 1,
		HAND = 1 << 2
	};
	ref_ptr<ShaderProgram> sceneShader;
	ref_ptr<ShaderProgram> towerShader;
	ref_ptr<HandCamera> handCamera;

	ref_ptr<MenuHUD> menu;

	ref_ptr<Group> towerScene;

	ref_ptr<View> top;

	ref_ptr<TextHUD> heightHUD;
	float bestHeight;

	virtual void checkHeight(float);

	bool mustBeInitialized = true;

	virtual void createScene();
	virtual void resetScene();
	virtual void clearScene();
	virtual void buildScene();

};