#pragma once

#include "osg/OsgViewerWidget.h"
#include "osg/OsgFunctions.h"
#include "physx/PhysxScene.h"
#include "leap/LeapManager.h"
#include "leap/LeapFunctions.h"
#include "fmod/FmodScene.h"

#include <osg/MatrixTransform>
#include <unordered_map>

#include "osg/KeyListener.h"
#include "osg/MouseListener.h"

#include "GameLoop.h"

using namespace osg;

class TeetairApplication : public osgViewer::View, public Leap::Listener, public KeyListener, public MouseListener, public PhysxScene, public FmodScene{
public:
	virtual ~TeetairApplication() {};

	virtual void keyPressEvent(QKeyEvent* event){};
	virtual void keyReleaseEvent(QKeyEvent* event){};

	virtual void mousePressEvent(QMouseEvent* event){};
	virtual void mouseReleaseEvent(QMouseEvent* event){};
	virtual void mouseDoubleClickEvent(QMouseEvent* event){};
	virtual void mouseMoveEvent(QMouseEvent* event){};
	virtual void wheelEvent(QWheelEvent* event){};

	virtual void frameEvent(){};
	virtual float simulationStep() { return 1.f / fps(); };
	virtual int fps() { return 50; };

	friend class GameLoop;
	friend class Teeter;
	friend class Jenga;

private:
	virtual void updatePoses();
	ref_ptr<Group> osgScene;

	typedef unordered_map<int, ref_ptr<osg::MatrixTransform>> TransformMap;
	TransformMap transforms;
};