#pragma once

#include "GameObject.h"
#include "Ribbon.h"

class Ground;
class Block;

class Ball : public GameObject{

public:
	Ball(Level& level);
	void contact(Ground& ground);
	void contact(Block& block);
	void trigger(Block& block);
	void untrigger(Block& block);

	void reset();

	MatrixTransform* getTransform() { return ballTransform.get(); }

protected:
	~Ball();

private:
	ref_ptr<Geode> ball;
	ref_ptr<MatrixTransform> ballTransform;
	ref_ptr<Ribbon> ribbon;
	ref_ptr<ShaderProgram> shader;
};