#pragma once

#include "GameObject.h"

#include <vector>

class Ball;

class Block : public GameObject{
public:
	Block(Level& level, float x, float y, int s, int b, std::vector<ref_ptr<Block>>& group, bool standalone, std::string type);

	virtual void contactedBy(Ball& ball) {}
	virtual void triggeredBy(Block& block) {}
	virtual void triggeredBy(Ball& ball) {}
	virtual void untriggeredBy(Ball& ball) {}

	float getX() { return x; }
	float getY() { return y; }
	float getHeight() { return height; }

protected:
	enum class GradientDirection{
		TOP,
		LEFT,
		BOTTOM,
		RIGHT,
		NONE // height block
	};

	std::vector<ref_ptr<Block>>& getGroup() { return group; }
	MatrixTransform* getTransform() { return transform.get(); }

	int fixBlockOnBoard();
	float blockStartHeight;
	float blockEndHeight;
	GradientDirection blockDirection;

	virtual ~Block() { }

private:

	void buildBlock(int b, bool standalone, std::string type);
	void buildConvexBlock(float start, float end, GradientDirection dir, bool standalone, std::string type);
	void buildHeightBlock(float height, bool standalone, std::string type);

private:
	std::vector<ref_ptr<Block>>& group;
	osg::ref_ptr<MatrixTransform> transform;
	float x;
	float y;
	float height;
};