#pragma once

#include "Block.h"

#include "osg/NodeCallback"

#include <functional>

class Ball;

class BlockGhost : public Block {

public:

	/// <summary>
	/// Determines whether the specified hue describes a ghost block.
	/// </summary>
	/// <param name="hue">The hue.</param>
	/// <returns>true if the hue is about 225</returns>
	static bool isHue(int hue) { return hue >= 215 && hue <= 235; }

	static BlockGhost* factory(Level& level, float x, float y, int s, int b, std::vector<ref_ptr<Block>>& group) { return new BlockGhost(level, x, y, s, b, group); }

	void triggeredBy(Block& block);

	void reset();

	void timerEvent();

protected:
	BlockGhost(Level& level, float x, float y, int s, int b, std::vector<ref_ptr<Block>>& group);
	~BlockGhost();

private:
	bool initiallyVisible;
	double duration;

	bool visible;
	void setVisible(bool v);

	std::function<void()> timerFunction;

	ref_ptr<Uniform> opaqueStart;
	ref_ptr<Uniform> opaqueEnd;
	ref_ptr<Uniform> opaque;
};