#pragma once

#include "Block.h"

class BlockStandard : public Block{
public:

	/// <summary>
	/// Determines whether the specified hue describes a standard block.
	/// </summary>
	/// <param name="hue">The hue.</param>
	/// <returns>true if the hue is about 90</returns>
	static bool isHue(int hue) { return hue >= 80 && hue <= 100; }

	static BlockStandard* factory(Level& level, float x, float y, int s, int b, std::vector<ref_ptr<Block>>& group) { return new BlockStandard(level, x, y, s, b, group); }

protected:
	BlockStandard(Level& level, float x, float y, int s, int b, std::vector<ref_ptr<Block>>& group);
	~BlockStandard() { }
};