#pragma once

#include <osg/Referenced>
#include <osg/ref_ptr>
#include <osg/Geode>
#include <osg/ShapeDrawable>
#include <osg/Geometry>
#include <osg/MatrixTransform>
#include "../osg/ShaderProgram.h"

#include <iostream>

class Level;
class Teeter;

using namespace osg;

class GameObject : public osg::Referenced{

public:
	GameObject(Level& level);
	virtual void contact(GameObject& object) { std::cout << "standard contact" << std::endl; }
	virtual void contactedBy(GameObject& trigger) { std::cout << "standard contactedBy" << std::endl; }
	virtual void trigger(GameObject& object) { std::cout << "standard trigger" << std::endl; }
	virtual void triggeredBy(GameObject& trigger) { std::cout << "standard triggeredBy" << std::endl; }
	virtual void untrigger(GameObject& object) { std::cout << "standard untrigger" << std::endl; }
	virtual void untriggeredBy(GameObject& trigger) { std::cout << "standard untriggeredBy" << std::endl; }
	virtual void reset() {}

	int getId() { return id; }

protected:
	virtual ~GameObject() {}

protected:
	Level& getLevel() { return level; }
	Teeter& getTeeter();

private:
	Level& level;

private:
	int id;
};