#include "Ground.h"
#include "Teeter.h"
#include "Level.h"
#include "Board.h"
#include "Ball.h"

Ground::Ground(Level& level)
: GameObject(level)
{
	ground = new osg::Geode;

	osg::ref_ptr<osg::ShapeDrawable> groundShape = new osg::ShapeDrawable(new osg::Box(osg::Vec3(0.0, 0.0, -10.0), 30.0, 30.0, 0.1));
	groundShape->setColor(osg::Vec4(0.2, 0.2, 0.2, 1.0));
	ground->addDrawable(groundShape.get());
	getLevel().addChild(ground.get());
	getTeeter().PX::createPlane(getId(), "holz", osg::Vec3(0.0, 0.0, -10.0), osg::Vec3(0.0, 0.0, 1.0), Level::Groups::GROUND, Level::Groups::BALL);
}

void Ground::contactedBy(Ball& ball) {
	getLevel().changeLives(-1, true);
}