#pragma once

#include "../TeetairApplication.h"

#include <osg/Vec3>
#include <osg/MatrixTransform>
#include <osg/Geometry>
#include <osg/NodeCallback>
#include <osg/Geode>
#include <osg/ref_ptr>
class Teeter;
class Ribbon : public osg::NodeCallback {
public:
	Ribbon(osg::Vec3 colorRGB, osg::MatrixTransform* followTransform, int followPhysxId, Teeter& teeter, osg::MatrixTransform* parentTransform);

protected:
	~Ribbon() { }

private:
	osg::Geometry* createRibbon(const osg::Vec3& colorRGB);

	osg::ref_ptr<osg::Geometry> ribbon;
	osg::ref_ptr<osg::MatrixTransform> parent;
	float g_halfWidth = 0.3f;
	unsigned int g_numPoints = 50;
	int followPhysxId;
	Teeter& teeter;

	osg::ref_ptr<ShaderProgram> ribbonShader;

	virtual void operator()(osg::Node* node, osg::NodeVisitor* nv);
	
};