#include "FmodManager.h"

System* FmodManager::system() {
	static ref_ptr<FmodManager> manager = new FmodManager;
	return manager->fmodSystem;
}

FmodManager::FmodManager()
{
	result = System_Create(&fmodSystem);
	result = fmodSystem->getVersion(&version);

	result = fmodSystem->init(42, FMOD_INIT_NORMAL, 0);
	if (result != FMOD_OK) {
		printf("FMOD error %d - %s\n", result, FMOD_ErrorString(result));
	}
}


void FmodManager::cleanup() {
	int result = system()->release();

	if (result != FMOD_OK)
		printf("FMOD ERROR: System did not terminate properly!\n");
}

FmodManager::~FmodManager()
{}