#pragma once

#include <unordered_map>
#include <osg/Referenced>
#include <osg/ref_ptr>
#include <iostream>

#include "FmodManager.h"

using namespace std;
using namespace FMOD;
using namespace osg;

class FmodScene : public Referenced {
public:
	enum playmode {
		shot,
		loop
	};
	bool addSound(const string name, const string file);
	bool playSound(const string name, float volume = 1.0, playmode mode = shot, int *channelId = NULL);
	bool pauseSound(int channelId);
	bool unpauseSound(int channelId);
	bool stopSound(int channelId);

protected:
	virtual ~FmodScene();

private:

	FMOD_RESULT result;
	unordered_map<string, Sound*> sounds;
	unordered_map<int, Channel*> channels;

	static bool checkResult(FMOD_RESULT result);
	static System* system();
};

typedef FmodScene FM;