#include "LeapManager.h"

LeapManager* LeapManager::instance() {
	static ref_ptr<LeapManager> manager = new LeapManager;
	return manager.get();
}

LeapManager::LeapManager()
{}

void LeapManager::_setListener(Listener& leapListener) {
	if (listener)
		controller.removeListener(*listener);
	listener = &leapListener;
	controller.addListener(*listener);
}

void LeapManager::setListener(Listener& leapListener) {
	instance()->_setListener(leapListener);
}

void LeapManager::_removeListener() {
	if (listener)
		controller.removeListener(*listener);
}

void LeapManager::removeListener() {
	instance()->_removeListener();
}

void LeapManager::cleanup() {
	removeListener();
}

LeapManager::~LeapManager()
{}