#pragma once

#include "OsgFunctions.h"
#include <osgViewer/View>

class ContainerHUD;

class AbstractHUD : public osgGA::GUIEventHandler{
public:
	AbstractHUD() {};
	virtual void attachToScene(osg::Group*, osgViewer::View*);
	virtual void attachToContainer(ContainerHUD*);
	virtual void setGeode(osg::Geode*);
	osg::Geode* getGeode();
	virtual bool handle(const osgGA::GUIEventAdapter&, osgGA::GUIActionAdapter&, osg::Object*, osg::NodeVisitor*);
	virtual void show();
	virtual void hide();
	void toggleVisibility();
	void redraw();
	virtual void draw() = 0;
	virtual void clear();
	bool isVisible();
	int getWidth();
	int getHeight();
	virtual void setResolution(int, int);
protected:
	bool isInContainer;
	bool visible = false;
	int _width = 0;
	int _height = 0;
	ContainerHUD* _container;
	osg::ref_ptr<osg::Geode> _geode;
	osg::ref_ptr<osg::Group> _node;
	osg::ref_ptr<osgViewer::View> _view;
	osg::ref_ptr<osg::Projection> HUDProjectionMatrix;
	osg::ref_ptr<osg::MatrixTransform> HUDModelViewMatrix = new osg::MatrixTransform;
};
