#include "FileAssociatedAsset.h"

void FileAssociatedAsset::watchOn(const std::string filename) {
	watchOn(filename, this);
}

void FileAssociatedAsset::watchOn(const std::string filename, FileAssociatedAsset* asset){
	getWatcher()->addPath(QString::fromStdString(filename));
	assets.insert(QString::fromStdString(filename), asset);
}
void FileAssociatedAsset::stopWatching(const std::string filename) {
	stopWatching(filename, this);
}
void FileAssociatedAsset::stopWatching(const std::string filename, FileAssociatedAsset* asset){
	assets.remove(QString::fromStdString(filename), asset);
}

QFileSystemWatcher* FileAssociatedAsset::getWatcher() {
	static QFileSystemWatcher* watcher = createWatcher();
	return watcher;
}

QFileSystemWatcher* FileAssociatedAsset::createWatcher() {
	QFileSystemWatcher* watcher = new QFileSystemWatcher();
	QObject::connect(watcher, &QFileSystemWatcher::fileChanged, [=](const QString& filename) {
		std::cout << filename.toStdString() << " was changed" << std::endl;
		for (QMap<QString, FileAssociatedAsset*>::const_iterator i = assets.find(filename); i != assets.end() && i.key() == filename; ++i) {
			(*i)->notifyChanged(filename.toStdString());
		}
	});
	return watcher;
}

QMultiMap<QString, FileAssociatedAsset*> FileAssociatedAsset::assets = QMultiMap<QString, FileAssociatedAsset*>();