#pragma once

#include <QObject>
#include <QFileSystemWatcher>
#include <QMultiMap>

#include <iostream>

#include <osg/Referenced>
#include <osg/ref_ptr>

class FileAssociatedAsset : public virtual osg::Referenced
{
protected:
	virtual void notifyChanged(const std::string filename) = 0;
	void watchOn(const std::string filename);
	static void watchOn(const std::string filename, FileAssociatedAsset* asset);
	void stopWatching(const std::string filename);
	static void stopWatching(const std::string filename, FileAssociatedAsset* asset);

private:
	static QFileSystemWatcher* getWatcher();
	static QFileSystemWatcher* createWatcher();

	static QMultiMap<QString, FileAssociatedAsset*> assets;
};