#pragma once

#include <osgDB/ReadFile>
#include <osgText/TextBase>

#include "AbstractHUD.h"
#include "ShaderProgram.h"

class ImageHUD : public AbstractHUD {
public:
	ImageHUD();
	void attachToScene(osg::Group*, osgViewer::View*);
	void attachToContainer(ContainerHUD*);
	void draw();
	void setSourceFile(std::string);
	void setRelativePosition(osg::Vec2);
	void setRelativeDimension(osg::Vec2);
	void setAlignment(enum osgText::TextBase::AlignmentType);
protected:
	void addShader();
	osg::Vec2 offset(int, int);

	std::string _fileName;
	osg::Vec2 _relativePosition;
	osg::Vec2 _relativeDimension;
	enum osgText::TextBase::AlignmentType _alignment;
};
