#pragma once

#include <QWidget>

#include <osgViewer/CompositeViewer>
#include <osgQt/GraphicsWindowQt>

#include "KeyListener.h"
#include "MouseListener.h"
#include "ShaderProgram.h"

#include "../TeetairApplication.h"

using namespace osg;

class OsgViewerWidget : public osgQt::GLWidget, public osgViewer::CompositeViewer
{
public:
	OsgViewerWidget();

	GraphicsContext* getGraphicsContext() const;

	void paintEvent(QPaintEvent* event);

	void keyPressEvent(QKeyEvent* event);
	void keyReleaseEvent(QKeyEvent* event);
	
	void mousePressEvent(QMouseEvent* event);
	void mouseReleaseEvent(QMouseEvent* event);
	void mouseDoubleClickEvent(QMouseEvent* event);
	void mouseMoveEvent(QMouseEvent* event);
	void wheelEvent(QWheelEvent* event);

	void registerKeyListener(KeyListener* listener);
	void unregisterKeyListener(KeyListener* listener);
	void registerMouseListener(MouseListener* listener);
	void unregisterMouseListener(MouseListener* listener);

private:
	std::list<KeyListener*> keyListeners;
	std::list<MouseListener*> mouseListeners;
};