#pragma once

#include <osgText/Text>
#include <osgDB/ReadFile>

#include "AbstractHUD.h"
#include "ShaderProgram.h"

class TextHUD : public AbstractHUD {
public:
	TextHUD() { };
	void attachToScene(osg::Group*, osgViewer::View*);
	void attachToContainer(ContainerHUD*);
	void setText(std::string);
	void setSize(float);
	void setRelativePosition(osg::Vec2);
	void setAlignment(enum osgText::TextBase::AlignmentType);
	void setColor(osg::Vec4);
	void draw();
protected:
	virtual void addShader();

	float _size = 30;
	std::string _text;
	osg::Vec2 _relativePosition;
	enum osgText::TextBase::AlignmentType _alignment = osgText::TextBase::AlignmentType::CENTER_CENTER;
	osg::Vec4 _color = osg::Vec4(0, 0, 0, 1);
};
